defmodule AoC2021.Test15 do
  use ExUnit.Case, async: true

  alias AoC2021.Day15

  @data %{
    {0, 0} => 1, {1, 0} => 1, {2, 0} => 6, {3, 0} => 3, {4, 0} => 7, {5, 0} => 5, {6, 0} => 1, {7, 0} => 7, {8, 0} => 4, {9, 0} => 2,
    {0, 1} => 1, {1, 1} => 3, {2, 1} => 8, {3, 1} => 1, {4, 1} => 3, {5, 1} => 7, {6, 1} => 3, {7, 1} => 6, {8, 1} => 7, {9, 1} => 2,
    {0, 2} => 2, {1, 2} => 1, {2, 2} => 3, {3, 2} => 6, {4, 2} => 5, {5, 2} => 1, {6, 2} => 1, {7, 2} => 3, {8, 2} => 2, {9, 2} => 8,
    {0, 3} => 3, {1, 3} => 6, {2, 3} => 9, {3, 3} => 4, {4, 3} => 9, {5, 3} => 3, {6, 3} => 1, {7, 3} => 5, {8, 3} => 6, {9, 3} => 9,
    {0, 4} => 7, {1, 4} => 4, {2, 4} => 6, {3, 4} => 3, {4, 4} => 4, {5, 4} => 1, {6, 4} => 7, {7, 4} => 1, {8, 4} => 1, {9, 4} => 1,
    {0, 5} => 1, {1, 5} => 3, {2, 5} => 1, {3, 5} => 9, {4, 5} => 1, {5, 5} => 2, {6, 5} => 8, {7, 5} => 1, {8, 5} => 3, {9, 5} => 7,
    {0, 6} => 1, {1, 6} => 3, {2, 6} => 5, {3, 6} => 9, {4, 6} => 9, {5, 6} => 1, {6, 6} => 2, {7, 6} => 4, {8, 6} => 2, {9, 6} => 1,
    {0, 7} => 3, {1, 7} => 1, {2, 7} => 2, {3, 7} => 5, {4, 7} => 4, {5, 7} => 2, {6, 7} => 1, {7, 7} => 6, {8, 7} => 3, {9, 7} => 9,        
    {0, 8} => 1, {1, 8} => 2, {2, 8} => 9, {3, 8} => 3, {4, 8} => 1, {5, 8} => 3, {6, 8} => 8, {7, 8} => 5, {8, 8} => 2, {9, 8} => 1,
    {0, 9} => 2, {1, 9} => 3, {2, 9} => 1, {3, 9} => 1, {4, 9} => 9, {5, 9} => 4, {6, 9} => 4, {7, 9} => 5, {8, 9} => 8, {9, 9} => 1
  }

  test "setup" do
    assert Day15.setup("#{__DIR__}/data/test.txt") === @data
  end

  test "part1" do
    assert Day15.part1(@data) === 40
  end

  test "part2" do
    assert Day15.part2(@data) === 315
  end
end
